package com.taover.util;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Properties;

public class UtilProperties {
	public static String getPropertiesContent(String fileName){		
		InputStream inStream = UtilProperties.class.getClassLoader().getResourceAsStream("/conf/"+fileName);		
		try {
			BufferedInputStream bis = new BufferedInputStream(inStream);						
			byte[] bufferByte = new byte[bis.available()]; 
			bis.read(bufferByte);
			return new String(bufferByte, "UTF-8");
		} catch (IOException e) {			
			StringWriter sw = new StringWriter();
    		e.printStackTrace(new PrintWriter(sw, true));
    		return "";
		}
	}
	
	public static Properties getPropertiesByFilename(String fileName){
		InputStream inStream = UtilProperties.class.getClassLoader().getResourceAsStream("/conf/"+fileName);
		InputStreamReader inStreamReader = null;
		try {
			inStreamReader = new InputStreamReader(inStream, "utf-8");
			Properties properties = new Properties();
			properties.load(inStreamReader);
			return properties;
		} catch (IOException e) {			
			StringWriter sw = new StringWriter();
    		e.printStackTrace(new PrintWriter(sw, true));
    		return null;
		}
	}
	
	public static String getEnvironmentValue(String propertyFileName, String key){
		Properties prop = UtilProperties.getPropertiesByFilename(propertyFileName);
		return prop.getProperty(key);
	}
	
}
