package com.taover.util.bean;

public class UtilResultInfo {
	public static final String OK ="ok";
	public static final String FAIL ="fail";
	public static final String NOT_AUTHORIZED ="not_authorized";
		
	public static ResultInfo getFailure(String error){
		return getResultInfo(UtilResultInfo.FAIL, error, null);
	}

	public static ResultInfo getFailure(String error, Object data){
		return getResultInfo(UtilResultInfo.FAIL, error, data);
	}

	public static ResultInfo getSuccess(String error){
		return getResultInfo(UtilResultInfo.OK, error, null);
	}

	public static ResultInfo getSuccess(String error, Object data){
		return getResultInfo(UtilResultInfo.OK, error, data);
	}

	public static ResultInfo getNotAuthorized(String error){
		return getResultInfo(UtilResultInfo.NOT_AUTHORIZED, error, null);
	}
	
	public static ResultInfo getNotAuthorized(String error, Object data){
		return getResultInfo(UtilResultInfo.NOT_AUTHORIZED, error, data);
	}
	
	public static ResultInfo getResultInfo(String code, String error, Object data){
		return new ResultInfo(code, error, data);
	}
	
	public static ResultInfoException getExceptionFailure(String error){
		return getResultInfoException(UtilResultInfo.FAIL, error, null);
	}

	public static ResultInfoException getExceptionFailure(String error, Object data){
		return getResultInfoException(UtilResultInfo.FAIL, error, data);
	}

	public static ResultInfoException getExceptionSuccess(String error){
		return getResultInfoException(UtilResultInfo.OK, error, null);
	}

	public static ResultInfoException getExceptionSuccess(String error, Object data){
		return getResultInfoException(UtilResultInfo.OK, error, data);
	}

	public static ResultInfoException getExceptionNotAuthorized(String error){
		return getResultInfoException(UtilResultInfo.NOT_AUTHORIZED, error, null);
	}
	
	public static ResultInfoException getExceptionNotAuthorized(String error, Object data){
		return getResultInfoException(UtilResultInfo.NOT_AUTHORIZED, error, data);
	}
	
	public static ResultInfoException getResultInfoException(String code, String error, Object data){
		return new ResultInfoException(code, error, data);
	}
	
	public static ResultInfoException getExceptionFromResultInfo(ResultInfo result){
		return getResultInfoException(result.getCode(), result.getCode(), result.getData());
	}
}
